Vue UI Components Documentation

Vue Layout Component

The Layout component for Vue allows the creation of complex layouts with panels that can be nested, resized, pinned, unpinned and closed.

Prerequisites

Refer to Vue Getting Started before you start with this help topic.

Configuration

After you have created your App.vue file, here is how you should structure it:

The Layout component for Vue requires the following import:


Add the jqxLayout component to the components section of the the Vue class:


Template

The App.vue has a <template> structural tag where we determine the application structure. There we will also set the tags for the new components - <JqxLayout/>

<template>
<JqxLayout :width="width" :layout="layout">
<div data-container="Document1Panel">Document 1 content</div>
<div data-container="Document2Panel">Document 2 content</div>
<div data-container="ErrorListPanel">List of errors</div>
<div data-container="OutputPanel">Output</div>
<div data-container="SolutionExplorerPanel">Solution structure</div>
<div data-container="PropertiesPanel">List of properties</div>
</JqxLayout>
</template>

Properties

The properties of the <JqxLayout/> component are defined in the data member of the Vue class. We should put them in the return object of the data function:


Events

The events in Vue are set as an attribute with @ prefix, for example:


All events that are bound to a component are implemented in the methods member of the Vue class.


Methods

To use a component's method we should have its reference. In Vue we refer to a component by the special $refs property. Before that we need to add the desired name reference to that component:

<JqxLayout ref="layout"></JqxLayout>

Here how you can use a component's method:

this.$refs.layout.refresh();

methods: {
// Add here all used callbacks and/or events
onResize: function () {
// Do something...
this.$refs.layout.refresh();
}
}

If we want to add additional methods we should also implement them in the methods member.

In case we need to do some precalculation or something else before the components are rendered, we should use the beforeCreate member. It depends on the case.

If you have followed the above steps, you App.vue file would look like this:

App.vue:

<template>
<JqxLayout ref="layout" @resize="onResize()"
:width="width" :layout="layout">
<div data-container="Document1Panel">Document 1 content</div>
<div data-container="Document2Panel">Document 2 content</div>
<div data-container="ErrorListPanel">List of errors</div>
<div data-container="OutputPanel">Output</div>
<div data-container="SolutionExplorerPanel">Solution structure</div>
<div data-container="PropertiesPanel">List of properties</div>
</JqxLayout>
</template>
<script>
// Import the components that will be used
import JqxLayout from "jqwidgets-scripts/jqwidgets-vue/vue_jqxlayout.vue";
export default {
components: {
// Adding imported widgets here
JqxLayout
},
data: function () {
// Define properties which will use in the widget
return {
width: '100%',
layout: [{
type: 'layoutGroup',
orientation: 'horizontal',
items: [{
type: 'layoutGroup',
orientation: 'vertical',
width: '60%',
items: [{
type: 'documentGroup',
height: '50%',
minHeight: '25%',
items: [{
type: 'documentPanel',
title: 'Document 1',
contentContainer: 'Document1Panel'
}, {
type: 'documentPanel',
title: 'Document 2',
contentContainer: 'Document2Panel'
}]
}, {
type: 'tabbedGroup',
height: '50%',
pinnedHeight: '10%',
items: [{
type: 'layoutPanel',
title: 'Error List',
contentContainer: 'ErrorListPanel'
}, {
type: 'layoutPanel',
title: 'Output',
contentContainer: 'OutputPanel',
selected: true
}]
}]
}, {
type: 'tabbedGroup',
width: '40%',
items: [{
type: 'layoutPanel',
title: 'Solution Explorer',
contentContainer: 'SolutionExplorerPanel'
}, {
type: 'layoutPanel',
title: 'Properties',
contentContainer: 'PropertiesPanel'
}]
}]
}]
}
},
beforeCreate: function () {
// Add here any data where you want to transform before components be rendered
},
methods: {
// Add here all used callbacks and/or events
onResize: function () {
// Do something...
this.$refs.layout.refresh();
}
}
}
</script>
<style>
</style>

Layout Example

<template>
<div>
<JqxLayout ref="myLayout" :width="width" :height="600" :layout="layout">
<!--The panel content divs can have a flat structure-->
<!--autoHideGroup-->
<div data-container="ToolboxPanel">
List of tools
</div>
<div data-container="HelpPanel">
Help topics
</div>
<!--documentGroup-->
<div data-container="Document1Panel">
Document 1 content
</div>
<div data-container="Document2Panel">
Document 2 content
</div>
<!--bottom tabbedGroup-->
<div data-container="ErrorListPanel">
List of errors
</div>
<div data-container="OutputPanel">
Output
</div>
<!--right tabbedGroup-->
<div data-container="SolutionExplorerPanel">
<div id="treeContainer" style="border: none;"></div>
</div>
<div data-container="PropertiesPanel">
List of properties
</div>
</JqxLayout>
<div style="margin-top: 25px">
<JqxButton @click="saveLayoutBtnOnClick()">Save Layout</JqxButton>
<JqxButton ref="myLoadLayoutBtn" @click="loadLayoutBtnOnClick()" :disabled="true">Load Layout</JqxButton>
</div>
</div>
</template>
<script>
import JqxLayout from "jqwidgets-scripts/jqwidgets-vue/vue_jqxlayout.vue";
import JqxButton from "jqwidgets-scripts/jqwidgets-vue/vue_jqxbuttons.vue";
import JqxTree from "jqwidgets-scripts/jqwidgets-vue/vue_jqxtree.vue";
export default {
components: {
JqxLayout,
JqxButton
},
data: function () {
return {
width: 800,
layout: [{
type: 'layoutGroup',
orientation: 'horizontal',
items: [{
type: 'autoHideGroup',
alignment: 'left',
width: 80,
unpinnedWidth: 200,
items: [{
type: 'layoutPanel',
title: 'Toolbox',
contentContainer: 'ToolboxPanel'
}, {
type: 'layoutPanel',
title: 'Help',
contentContainer: 'HelpPanel'
}]
}, {
type: 'layoutGroup',
orientation: 'vertical',
width: 500,
items: [{
type: 'documentGroup',
height: 400,
minHeight: 200,
items: [{
type: 'documentPanel',
title: 'Document 1',
contentContainer: 'Document1Panel'
}, {
type: 'documentPanel',
title: 'Document 2',
contentContainer: 'Document2Panel'
}]
}, {
type: 'tabbedGroup',
height: 200,
pinnedHeight: 30,
items: [{
type: 'layoutPanel',
title: 'Error List',
contentContainer: 'ErrorListPanel'
}, {
type: 'layoutPanel',
title: 'Output',
contentContainer: 'OutputPanel',
selected: true
}]
}]
}, {
type: 'tabbedGroup',
width: 220,
minWidth: 200,
items: [{
type: 'layoutPanel',
title: 'Solution Explorer',
contentContainer: 'SolutionExplorerPanel',
initContent: () => {
jqwidgets.createInstance('#treeContainer', 'jqxTree', { source: this.source, height: '99%', width: '100%' })
}
},
{
type: 'layoutPanel',
title: 'Properties',
contentContainer: 'PropertiesPanel'
}]
}]
}]
}
},
beforeCreate: function () {
this.source = [{
icon: 'images/earth.png',
label: 'Project',
expanded: true,
items: [{
icon: 'images/folder.png',
label: 'css',
expanded: true,
items: [{
icon: 'images/nav1.png',
label: 'jqx.base.css'
}, {
icon: 'images/nav1.png',
label: 'jqx.energyblue.css'
}, {
icon: 'images/nav1.png',
label: 'jqx.orange.css'
}]
}, {
icon: 'images/folder.png',
label: 'scripts',
items: [{
icon: 'images/nav1.png',
label: 'jqxcore.js'
}, {
icon: 'images/nav1.png',
label: 'jqxdata.js'
}, {
icon: 'images/nav1.png',
label: 'jqxgrid.js'
}]
}, {
icon: 'images/nav1.png',
label: 'index.htm'
}]
}];
this.savedLayout;
},
methods: {
saveLayoutBtnOnClick: function () {
this.savedLayout = this.$refs.myLayout.saveLayout();
this.$refs.myLoadLayoutBtn.disabled = false;
},
loadLayoutBtnOnClick: function () {
this.$refs.myLayout.loadLayout(this.savedLayout);
this.$refs.myLoadLayoutBtn.disabled = true;
}
}
}
</script>
<style>
.jqx-layout-group-auto-hide-content-vertical {
width: 200px;
}
.jqx-button {
width: fit-content;
display: inline;
margin-right: 5px;
}
</style>

Run Code

Angular UI Components Documentation

Angular Layout Component

The Layout component for Angular which allows the creation of complex layouts with panels that can be nested, resized, pinned, unpinned and closed.

1. Installation

The easiest way to get started with jQWidgets UI for Angular is to use the Angular CLI Tool. To scaffold your project structure, follow its installation instructions.

npm install -g @angular/cli
ng new jqwidgets-project
cd jqwidgets-project

Install jQWidgets

jQWidgets Angular UI comes packaged with Angular CLI schematics to make creating Angular applications easier. Schematics are included with both @angular/cdk and jqwidgets-ng. Once you install the npm packages, they will be available through the Angular CLI.

Angular CLI supports the addition of packages through the ng add command. The ng add command provides faster and more user-friendly package installation. To install the jQWidgets UI for Angular package, use ng add and add the name of the NPM package:

ng add jqwidgets-ng

Alternatively, you can use the standard installation (Manual Setup)

jQWidgets UI for Angular is distributed as jqwidgets-ng NPM package

  1. Download and install the package.
    npm install jqwidgets-ng
  2. Adding CSS reference

    The following CSS file is available in ../node_modules/jqwidgets-ng/ package folder. This can be referenced in [src/styles.css] using following code.

    @import 'jqwidgets-ng/jqwidgets/styles/jqx.base.css';

    Another way to achieve the same is to edit the angular.json file and in the styles add the style.

    "styles": [
    	"node_modules/jqwidgets-ng/jqwidgets/styles/jqx.base.css"
    ]
    

2. Add the HTML for jQWidgets component in src/app/app.component.html

app.component.html


<jqxLayout [theme]="'fluent'" [width]="getWidth()" [height]="600" [layout]="layout">
    <!--The panel content divs can have a flat structure-->
    <!--autoHideGroup-->
    <div data-container="ToolboxPanel">
       List of tools
    </div>
    <div data-container="HelpPanel">
        Help topics
    </div>
    <!--documentGroup-->
    <div data-container="Document1Panel">
        Document 1 content
    </div>
    <div data-container="Document2Panel">
        Document 2 content
    </div>
    <!--bottom tabbedGroup-->
    <div data-container="ErrorListPanel">
        List of errors
    </div>
    <div data-container="OutputPanel">
        Output
    </div>
    <!--right tabbedGroup-->
    <div data-container="SolutionExplorerPanel">
        <div id="treeContainer" style="border: none;"></div>
    </div>
    <div data-container="PropertiesPanel">
        List of properties
    </div>
</jqxLayout>	

3. Setup Component Logic

app.component.ts


import { Component, ViewEncapsulation } from '@angular/core';

import { jqxLayoutModule, jqxLayoutComponent } from 'jqwidgets-ng/jqxlayout';
@Component({
    selector: 'app-root',
    imports: [jqxLayoutModule],
    standalone: true,
    templateUrl: './app.component.html',
    styleUrls: ['./app.component.css'],
    encapsulation: ViewEncapsulation.None
})

export class AppComponent {

    getWidth(): any {
        if (document.body.offsetWidth < 800) {
            return '90%';
        }

        return 800;
    }

    source: any[] =
        [{
            icon: 'https://www.jqwidgets.com/angular/images/earth.png',
            label: 'Project',
            expanded: true,
            items: [{
                icon: 'https://www.jqwidgets.com/angular/images/folder.png',
                label: 'css',
                expanded: true,
                items: [{
                    icon: 'https://www.jqwidgets.com/angular/images/nav1.png',
                    label: 'jqx.base.css'
                }, {
                    icon: 'https://www.jqwidgets.com/angular/images/nav1.png',
                    label: 'jqx.energyblue.css'
                }, {
                    icon: 'https://www.jqwidgets.com/angular/images/nav1.png',
                    label: 'jqx.orange.css'
                }]
            }, {
                icon: 'https://www.jqwidgets.com/angular/images/folder.png',
                label: 'scripts',
                items: [{
                    icon: 'https://www.jqwidgets.com/angular/images/nav1.png',
                    label: 'jqxcore.js'
                }, {
                    icon: 'https://www.jqwidgets.com/angular/images/nav1.png',
                    label: 'jqxdata.js'
                }, {
                    icon: 'https://www.jqwidgets.com/angular/images/nav1.png',
                    label: 'jqxlayout.js'
                }]
            }, {
                icon: 'https://www.jqwidgets.com/angular/images/nav1.png',
                label: 'index.htm'
            }]
        }];

    layout: any[] =
        [{
            type: 'layoutGroup',
            orientation: 'horizontal',
            items: [{
                type: 'autoHideGroup',
                alignment: 'left',
                width: 80,
                unpinnedWidth: 200,
                items: [{
                    type: 'layoutPanel',
                    title: 'Toolbox',
                    contentContainer: 'ToolboxPanel'
                }, {
                    type: 'layoutPanel',
                    title: 'Help',
                    contentContainer: 'HelpPanel'
                }]
            }, {
                type: 'layoutGroup',
                orientation: 'vertical',
                width: 254,
                items: [{
                    type: 'documentGroup',
                    height: 400,
                    minHeight: 200,
                    items: [{
                        type: 'documentPanel',
                        title: 'Document 1',
                        contentContainer: 'Document1Panel'
                    }, {
                        type: 'documentPanel',
                        title: 'Document 2',
                        contentContainer: 'Document2Panel'
                    }]
                }, {
                    type: 'tabbedGroup',
                    height: 200,
                    pinnedHeight: 30,
                    items: [{
                        type: 'layoutPanel',
                        title: 'Error List',
                        contentContainer: 'ErrorListPanel'
                    }, {
                        type: 'layoutPanel',
                        title: 'Output',
                        contentContainer: 'OutputPanel',
                        selected: true
                    }]
                }]
            }, {
                type: 'tabbedGroup',
                width: 150,
                minWidth: 150,
                items: [{
                    type: 'layoutPanel',
                    title: 'Solution Explorer',
                    contentContainer: 'SolutionExplorerPanel',
                    initContent: () => {
                        jqwidgets.createInstance('#treeContainer', 'jqxTree', { theme: 'material', source: this.source, height: '99%', width: '100%' })
                    }
                },
                {
                    type: 'layoutPanel',
                    title: 'Properties',
                    contentContainer: 'PropertiesPanel'
                }]
            }]
        }];
}

Summary

jQWidgets UI for Angular provides an easy way to integrate robust UI components into your Angular project. By using either the ng add command or manual setup, you can quickly get started. Once the setup is complete, you can add the desired jQWidgets components and configure them in your Angular components to match your application requirements.

Layout API

API Reference of the jQWidgets Layout component for Angular: Layout API

React UI Components Documentation

Typescript React Layout Component

This tutorial will show you the basics of how to get started with the jQWidgets Layout React Component.

Prerequisites

Refer to Getting Started with React before you start with this help topic.

Structure


I. Imports:

import * as React from 'react';
import 'jqwidgets-scripts/jqwidgets/styles/jqx.base.css';
import 'jqwidgets-scripts/jqwidgets/styles/jqx.material-purple.css';
import JqxLayout, { ILayoutProps } from 'jqwidgets-scripts/jqwidgets-react-tsx/jqxlayout';

II. Class:

class App extends React.PureComponent<{}, ILayoutProps> {
constructor(props: {}) {
super(props);
this.state = {
width: '100%'
// Other Widget Props
}
}
render() {
return (
<JqxLayout
width={this.state.width} height={"100%"} .....
/>
)
}
}

III. Render:

ReactDOM.render(<App />, document.getElementById('app'));

Events

The event names in React are constructed of the original event names starting with capital letter plus on upfront:

class App extends React.PureComponent<{}, ILayoutProps> {
constructor(props: {}) {
super(props);
this.state = {
width: '100%'
// Other Widget Props
}
}
render() {
return (
<JqxLayout onNameOfEvent={this.handleEvent}
width={this.state.width} height={"100%"} .....
/>
)
}
private handleEvent(e: Event): void {
// Do Something ...
}
}

Methods & Properties

This is how you call methods & props:

Every component have a method setOptions which accepts a object as an argument. This object contains component settings.

Every component also have a method getOptions which returns the value of the requested option.

Layout API

API Reference of the jQWidgets Layout React Component: Layout API

Layout Demos

Demos Reference of the jQwidgets Layout React Component: Layout Demos